TbaMUD is currently being developed by The Builder Academy. If you need any
help, find any bugs, or have ideas for improvement please stop by TBA at 
telnet://tbamud.com:9091 or email rumble@tbamud.com --Rumble
@
Development moved to Github in 2013, this document is no longer updated:
https://github.com/tbamud/tbamud
Changelog also available on Github:
https://github.com/tbamud/tbamud/commits/master
Changes prior to Github transition:
[Jun 21 2013] - Vatiken
  Added 'toupper' as a dg_script command to capitalize the first letter
  of a string.
[Apr 11 2013] - Rumble
  Added color parsing to wiznet.
[Apr 10 2013] - Rumble
  Another wiznet fix to add returns for add_history.
[Apr 10 2013] - Fizban
  Fixed wiznet so it is viewable in OLC again.
[Apr 09 2013] - Rumble
  Fixed warning in genzon.c checking bottom_of_zone. (Thanks Fizban)
[Apr 08 2013] - Rumble
  Fixed color bleeding in level range menu. (Thanks Silvaria)
  Fixed typos, updated help.
[Apr 03 2013] - Rumble
  Fixed typo in Whirlwind
  Added color to poofs.
[Mar 02 2013] - Rumble
  Updated World and files for 3.64 release.
[Feb 12 2013] - Vatiken
  feature: New group system.
  feature: Room events.
  bug: Many small bug fixes.
[Sep 08 2012] - Rumble
  added another example to doc/syserr.txt
  Added a !NPC check to can_take_object. It was spamming a "mob using player data SYSERR". 
This means mobs do not have a max weight carrying capacity anymore. I think this is a good 
thing because I've seen people stumped when mob triggers fail due to weight limitations. 
But it could be unbalancing on some MUDs since pets could then carry unlimited gear.
[Aug 22 2012] - Rumble
  bug: moved cedit load_config of no_mort_to_immort to its proper place. (thanks Liko)
[Aug 12 2012] - Vatiken
  bug: fixed typo in dg_variables.c (Thanks Zusuk)
[Aug 08 2012] - Vatiken
  bug: fixed another copyover issue that resulted in dying character respawning at corpse.
  bug: fixed an issue where a PC could be remembered after dying. (Thanks Zusuk)
  improve: cleaned up some code and did some colour adjustments.
  feature: new debug toggle with 4 settings.
  bug: fixed an issue with hedit that prevented editing of certain helpfiles.
  feature: added message editor for combat messages.
  bug: fixed a small bug with colour codes in interpreter.c.
  bug: fixed crash bug in oasis_lists.c caused by buffer overflows.
  bug: fixed issue with certain clients that were adding extra new-lines.
  bug: fixed crash bug in improved editor.
  improve: cedit toggle for colour codes in comm channels.
  typo: Fixed typo in do_scan.
[May 28 2012] - Vatiken
  bug: Fixed a MAJOR duping issue.
[May 24 2012] - Vatiken
  improve: prefedit now allows toggling of "this" session protocols
tbaMUD 3.63
[Apr 04 2012] - Rumble
  Updated World and files for 3.63 release.
[Mar 31 2012] - Vatiken
  improve: updated some of the documents.
  feature: added the 'whirlwind' skill as a event/list template
  feature: protocol system now can be deactivated thru cedit
  improve: 256 to ANSI conversions changed to reflect the new colouring scheme
  feature: added blink, underline, bold, reverse and '@' to the protocol system
[Mar 25 2012] - Vatiken
  feature: whois now lists protocol informations when used by an immortal
  improve: proc_colors() has been removed, and tbaMUD has been made backwards compatible for
    systems still using '@' symbols for colour.
  feature: added underline, bold, reverse, and flashing text to the protocol system.
  bug: Fixed a glitch within protocol.h that had defines differing from similar tbaMUD defines.
  feature: added oset() to allow modification of individual objects through commands or dg_scripts.
  improve: Adjusted protocolinput() and processinput() to be more efficient.
  bug: Fixed major leak in the history system
[Feb 12 2012] - Vatiken
  bug: do_score, changed level 30 to LVL_IMMORT
  bug: the NOHASSLE flag allows imms to carry unlimited weight
  idea: dexterity now affects whether a character gets the first hit
  idea: advance to immortal now sets hunger/thirst to -1
  feature: color is now an option on do_show, which shows all 256 color options
  feature: active lists has now been added to do_show, under 'stats'
  feature: added KaVir's protocol snippet
  bug: protocol snippet should now properly detect xterm color
  bug: protocol settings should now be preserved after copyover
  idea: ibt now time stamps when something is submitted
  feature: added a new MUD event system (mud_event.c)
  feature: added a display_usage() event, which is basically an event/list tester.
  feature: added two new parsing commands to modify.c for converting tabs to @ and back
  feature: added a new MUD list system (lists.c)
  improve: qedit now uses '\t' instead of '@' to show color
  improve: sedit now uses '\t' instead of '@' to show color
  issues: may be bugs with strfrmt() while converting '@' to '\t'
[Feb 04 2012] - Vatiken
  Feature: Added 'Experience' and 'Thaco' to the do_show() command.
  Bug Fix: Nipped a bug where shopkeepers weren't sending tells.
  Visuals: Fixed a small glitch in redit where things weren't lining up right with extra dirs activated.
  Made olist, mlist, and rlist, page_string() compatible.
  Bug Fix: Editing extra directions is now doable from redit.
  MAJOR: Reverted back to 3.62 Revision 241, followed up by backporting bug fixes and some of the positive changes implemented by Jamdog. Not coming along for the ride currently are the new mail system, housing system and the admin level system.
[Nov 06 2010] - Jamdog
  Added HappyHour feature
  Added game_info function for sending global messages to all players
  Added ability to change player/mob level or class in scripts 
  The medit mob flags menu now only shows valid flags (thanks Kyle)
  Skillset now warns imms when the player shouldn't have a skill (thanks Rumble)
  Fly spell added!
  Added recent command
  Bug Fix: Now imms show on who list when editing IBT notes.
[Nov 04 2010] - Jamdog
  Bug-Fix: Converted affect flags in struct affected_type from 32-bit to 128-bit
  Bug Fix: Players with too much gold now don't lose eq when renting
  Bug Fix: Cured SYSERR when selecting an unimplemented obj type in oedit (thanks Rumble)
  Bug Fix: Scan no longer shows the content of dark rooms (thanks Mirad)
  Removed conf.h fron the SVN, as this is created by the configure script
  Minor IBT system change for accurately finding who logged an IBT
  Minor IBT change to list 'in-progress' IBT's in yellow
  Bug Fix: Webster added to the util makefile for make all (wasn't compiling)
  Update to webster code to hopefully fix 'tell m-w' bug
  IBT's no longer read preceding spaces (body and notes), which inserts spaces every copyover
[Nov 01 2010] - Rumble
  Fixed do_scan crash due to exits to NOWHERE. (thanks Rhade)
  Changed do_score experience tnl to list only mortals since LVL_IMMORT showed negative EXP.
[Oct 30 2010] - Jamdog
  Added ability for players to list/show their own ideas, bugs and typos (thanks Frenze)
  Added more details to header for idea/bug/typo show command (thanks Parna)
[Oct 20 2010] - Rumble
  Fixed freeing of null pointers in ibt.c (thanks Stoneheart)
[Sep 28 2010] - Rumble
  Fixed a couple NPC accessing player data errors.
  Fixed oedit extra desc's from always showing "Set" even if they weren't. (thanks Mirad)
tbaMUD 3.62
[Sep 19 2010] - Rumble
  Updated World and files for 3.62 release.
[Sep 11 2010] - Rumble
  Fixed non-unix file formats and permissions. (thanks Mirad)
[Jul 26 2010] - Rumble
  Corrected several bad wear flags on objects. (thanks Insomnia)
[Jul 12 2010] - Rumble
  Fixed bad sector types. (thanks Insomnia)
[Jul 06 2010] - Rumble
  Numerous typo fixes and World files added to SVN. (thanks Insomnia)
  Fixed medit alignment menu to return you to stats menu after entry. (thanks Tink)
[Jul 03 2010] - Rumble
  Fixed oedit to allow setting of UNDEFINED object type. (thanks Tink)
  Fixed alias bug from using * as first character. (thanks Dio)
[Jun 20 2010] - Rumble
  Fixed two memory leaks. (thanks Dio)
[Jum 19 2010] - Fizban
  Changed Helpcheck from level 34 to level 32.
[Jun 07 2010] - Fizban
  Enabled nohassled immortals to give cursed items to other players.
[Jun 18 2010] - Rumble
  Fixed unaffect clearing ch affects and not vict. (thanks Drefs)
[May 24 2010] - Rumble
  Fixed bug in redit copy duplicating people in room. (thanks Anderyu)
[May 19 2010] - Rumble
  Gave Arne Troffaes proper credit for fixing Cygwin syslog rotation.
[May 16 2010] - Rumble
  Fixed bash, NO_BASH flag was being ignored. (thanks Anderyu)
[Apr 22 2010] - Rumble
  Fixed osetval not modifying AC on players. (thanks Rudeboyrave)
[Apr 12 2010] - Rumble 
  Fixed gain_exp quest reward that gave gold and not xp. (thanks Vatiken)
Mar 17 2010] - Fizban
  Made non-existant objects in pfiles be skipped instead of crashing the MUD (thanks drefs)
  Fixed plist overflow.
[Mar 11 2010] - Rumble
  Updated do_export_zone to include shop files (thanks Kyle)
[Mar 07 2010] - Rumble
  Updated do_scan. (thanks Zman)
[Feb 13 2010] - Rumble
  Removed delete object option in oedit menu.
[Feb 08 2010] - Rumble
  Added CIRCLE_WINDOWS check for tell m-w usage of getpid(). (thanks Kyle)
  Changed zcheck to ignore object type TRASH when checking for a cost of 0.
  Changed teleport level to LVL_BUILDER.
[Jan 27 2010] - Rumble
  Updated World (thanks Parna) and other text files for release.
[Jan 18 2010] - Fizban
  Edited scuba check so immortals with nohassle on don't need one.
[Jan 18 2010] - Rumble
  Fixed bad AFF_SCUBA check for underwater rooms.
tbaMUD 3.61
[Dec 28 2009] - Rumble
  Fixed bug where an immortal could cast 'invis' and then be unable to break it with vis.
[Dec 25 2009] - Rumble
  Added new mob flag NOKILL.
[Dec 23 2009] - Rumble
  Added zone flags and min/max level to show zone # and stat zone #.
  Changed show zone # reset mode from a # to the actual string description.
  Changed Message Type on stat object from a number to the actual message type. i.e. pierce.
[Dec 22 2009] - Rumble
  Made copyover save loadroom so players stay in the same room during copyover.
  Added scan command.
[Dec 21 2009] - Rumble
  Added identify command to shops.
  Moved identify to an active spell. Cleric 11, Mage 20.
[Dec 17 2009] - Rumble
  Standardized /n/r to /r/n in ibt.c
  Removed ability to set a modifier to obj apply NONE.
[Dec 16 2009] - Rumble
  Added some missing code for last_ibt in ibt.c.
  Fixed typos in ibt.c (thanks Elervan)
[Dec 13 2009] - Rumble
  Changed set password to level GRGOD.
[Dec 08 2009] - Rumble
  Added "current zone:" to immortal score.
[Dec 07 2009] - Rumble
  Renumbered UNUSED triggers to UNUSED# to make it easier to unset them when changing trig types. (thanks Parna)
  Fixed double free in IBT that caused crash on /a or saving without any description.
[Dec 06 2009] - Rumble
  Fixed medit autoroll so it would recognize a change and save.
[Dec 05 2009] - Rumble
  Changed zedit clear level restrictions to dump you back at main zedit menu instead of in the level menu.
  Changed zone level restriction to level recommendation so players would not be blocked from zones.
  Changed Zcheck to level 31.
[Nov 19 2009] - Rumble
  Fixed list obj max/min from room to obj. (thanks Elervan)
[Nov 13 2009] - Rumble
  Removed con_app 2nd apply type shock that was for "resurrection?" This was not used in 3.1.
[Nov 12 2009] - Rumble
  Fixed overflow in prefedit.c. (thanks Xiu)
[Nov 01 2009] - Rumble
  Renamed autorun log entries from autoscript killed to terminated so it wouldn't go into the log/rip file.
[Nov 01 2009] - Fizban
  Changed MOB_OR_IMPL macro to allow player-attachable scripts to work properly and edited the output of 'show zones'.
[Oct 27 2009] - Rumble
  Added zone 555/556 qst files.
  PLR_BUG/IDEA/TYPO flag cleanup.
[Oct 24 2009] - Jamdog
  Added new IBT system for Ideas, Bugs and Typos (thanks Frenze)
  **WARNING** This will create new files so backup your old ones first.
[Oct 23 2009] - Rumble
  Fixed bug in renumbering zone table after deleting mobiles. (thanks Drefs)
  Fixed bug in renumbering zone table after deleting objects. (thanks Drefs)
  Upgraded column_list to use player screenwidth to determine how many columns to create (use column arg of 0). (thanks Maclir)
[Oct 20 2009] - Rumble
  Corrected several PRF_FLAGGED checks that mobs were using.
  Removed l-desc from stat player and title from stat mob. (thanks Xiu)
[Oct 19 2009] - Rumble
  Added a note to spec_assign.c assign_mobiles that guildguard, snake, thief, magic user, puff, fido, janitor, and cityguards are now implemented via triggers.
  Fixed a bug where empty drink containers and fountains would show half empty. (thanks Parna)
[Oct 17 2009] - Rumble
  Added Ultima Zone 555 and 556. Originally by Casret, rebuilt by Parna.
  Made MEDIT column menu's consistent with other OLC menu's.
  added TEDIT access to bugs, typos, and ideas file.
[Oct 09 2009] - Rumble
  Added connected_type "Preference Edit" (thanks Maoliosa)
[Oct 08 2009] - Rumble
  Fixed do_purge to allow targetting of multiple objects of the same name. i.e. 2.knife. (thanks Drefs)
[Oct 07 2009] - Rumble
  Added CAN_SEE_IN_DARK and AFF_BLIND checks in do_automap. (thanks Frenze)
[Oct 06 2009] - Rumble
  Fixed do_cast to allow targetting of multiple objects of the same name. i.e. 2.knife. (thanks Drefs)
[Oct 04 2009] - Rumble
  Fixed a bug on filling unlimited containers where it doesn't update weight. (thanks Drefs)
[Oct 02 2009] - Rumble
  Fixed buildwalk so it does not require the first room to exist. (thanks Zizazat)
tbaMUD 3.6
[Aug 29 2009] - Rumble
  Removed unused prototype log_death_trap in utils.h (thanks Xiuhtecuhtli)
[Aug 28 2009] - Rumble
  Prevented players from taking objects currently being sat in. (thanks Frenze)
[Aug 26 2009] - Rumble
  Removed dupe include in genobj.c (thanks Xiuhtecuhtli)
[Aug 25 2009] - Rumble
  Fixed the range of barehandattack. (thanks Stoneheart)
[Aug 06 2009] - Rumble
  Fixed possible bug in the load_zone routine for giving items to mobs. (thanks Maoliosa)
[Jul 26 2009] - Rumble
  Added a char_from_furniture call in char_from_room.
  Removed medit_disp_stats_menu from MEDIT_SEX case.
  Updated a few socials and found a few typos.
[Jul 25 2009] - Rumble
  Fixed zedit_level to recognize changes and save properly.
  Removed duplicate struct from db.h
[Jul 04 2009] - Rumble
  added trigedit variable armor to return AC. (thanks Fizban)
  Fixed typo in do_advance PLR to PRF. (thanks Drefs)
[Jun 08 2009] - Jamdog
  Bug-Fix: DG-Scripts: If %actor% dies during a script, then %force% %actor% no longer crashes the MUD.
  Added 'set help' now displays a list of available set options (thanks Super)
[Jun 06 2009] - Jamdog
  Bug-Fix: prefedit: Editing screenwidth was setting pagelength value (thanks drefs)
[Jun 02 2009] - Jamdog
  Bug-Fix: furniture now will throw players to the floor when it is removed, and also count correctly. (Thanks MTFox)
[Jun 01 2009] - Jamdog
  Bug-Fix: toggle command not fully fixed in last update (sorry) - It's fixed this time!
[May 28 2009] - Jamdog
  Bug-Fix: toggle command broke adding autodoor/autokey - toggle color command is usable again!
[May 24 2009] - Jamdog
  Bug-Fix: sedit, copy shop option was causing a crash (Thanks slicer)
[May 21 2009] - Jamdog
  Added autoassist, autoloot, autogold, autosplit, autosacrifice and automap commands.
  Added autodoor toggle and command (autofind next door when opening/closing/unlocking/picking)
  Added autokey toggle and command (autounlock door when opening, if holding the key)
  Added prefedit OLC for players to set their toggles and preferences
  Re-arranged IS_PLAYING define to make it more efficient
[May 15 2009] - Jamdog
  Fixed variable definition halfway through do_oasis_zedit to allow compilation in MSVC. (thanks Lyceq)
  Crash-Bug-Fix: Added check for attacker and victim in the hit function (thanks Lyceq)
[May 13 2009] - Jamdog
  Bug-Fix: quest join check for previous quest completion, and validation checks for prev and next quests in qedit. (thanks drefs)
[Apr 13 2009] - Jamdog
  Bug-Fix: Shopping for multiple items caused an occasional crash due to NULL variable - now fixed (I hope)
[Apr 12 2009] - Jamdog
  Bug-Fix: Stat player displayed current quest information incorrectly - fixed 'if'
[Apr 11 2009] - Jamdog
  Bug-Fix: NPC check added to do_gen_ps function (thanks drefs)
  Bug-Fix: Fixed crash bug in remove_player where index entry is removed too early (thanks drefs)
  Bug-Fix: Commands and Socials list correctly when switched into a mob (thanks Rumble)
[Apr 06 2009] - Jamdog
  Bug-Fix: Changing a player name no longer allows two words (thanks Slicer)
[Apr 05 2009] - Jamdog
  Bug-Fix: Now frees memory used by qedit and hedit when closing a socket (Thanks Xiuhtecuhtli)
@
tbaMUD 3.59
[Apr 05 2009] - Rumble
  Updated World and files for 3.59 release.
[Apr 02 2009] - Rumble
  real_abils.str changed from 25 to 18. Since 18 is max str.
  Changed ch to k in do_stat for quests. (thanks Frenze)
[Mar 14 2009] - Jamdog
  Bug-Fix: real_shop function could hang if a shop was added with the max VNUM (Thanks Slicer)
  Removed find_shop function, which was a duplicate of real_shop.
[Mar 13 2009] - Jamdog
  Bug-Fix: Character deletion (remove_player, players.c), where the wrong player was potentially being deleted.
  Added Zone Flags, including zedit sub-menu
  Added Zone level restrictions, including zedit sub-menu
  Added zlock and zunlock commands
  Added areas command
  Set GRID flag on zones 0, 12 and 30
[Mar 08 2009] - Jamdog
  Fixed a possible crash bug in delete_object (genobj.c) (Thanks Slicer)
  CAP function now recognises both preceeding color codes and ANSI codes (Thanks Slicer)
[Mar 07 2009] - Jamdog
  Fixed a bug in find_shop (shop.c) and real_shop (genshp.c) (Thanks Slicer)
[Feb 25 2009] - Jamdog
  Fixed new medit stats menu so that it uses the the Advanced/Standard cedit toggle
[Feb 24 2009] - Jamdog
  Bug-Fix: Fixed levels command, so it only shows immortal level if it's in the specified range
  Bug-Fix: write_mobile_espec now saves CON and CHA values for mobiles in world files
  Bug-Fix: stat zone <num> now shows the same as vstat zone <num> (instead of show zone (num)
  Bug-Fix: zone 'stat' info (print_zone, oasis_list.c) now shows the number of shops and triggers
  Bug-Fix: zone 'show' info (print_zone_to_buf, act.wizard.c) now shows number of quests.
  Added saving throws to write_mobile_espec (genmob.c) and interpret_espec (db.c)
  Added 'whois' command for all players
  medit: All numerical stats moved to new sub-menu, with 'autoroll' option
  medit: Advanced or Standard stats sub-menu with cedit toggle (in Game Operations)
[Feb 17 2009] - Jamdog
  Fixed a bug with %obj.extra% so that it now returns the list of extra flags
[Feb 11 2009] - Jamdog
  Fixed a crash bug in count_quests (quest.c) affecting zlist (thanks Fsantin)
[Feb 05 2009] - Jamdog
  Added "set <player> name <newname>", which renames a character, including pfile and index entry
[Feb 01 2009] - Jamdog
  Changed documentation /doc unixshelladminguide to PDF format.
[Jan 31 2009] - Jamdog
  Added room login trig types, to catch players logging in to a particular room
[Jan 29 2009] - Rumble
  Corrected zcheck MAX_OBJ_GOLD_ALLOWED to compare against Val 0, not Val 1. (thanks Tails)
  Created new MAX_OBJ_GOLD_ALLOWED define for zcheck. (thanks Tails)
  Fixed typo in players.c. (thanks Tristen)
[Jan 25 2009] - Rumble
  Added new documentation /doc unixshelladminguide. (thanks Jamdog).
  Added new zone creation limits to prevent misuse of zedit making the MUD unbootable.
[Jan 25 2009] - Jamdog
  Added cases for missing object types in oedit_disp_val1_menu (other, worn, treasure, trash, key, pen, boat)
[Jan 25 2009] - Rumble
  Fixed pardon. (thanks Echos-Ironcastle)
[Jan 24 2009] - Rumble
  Fixed command queue cancelling "--" from cancelling the next command. (thanks Frenze/Ogdin)
  Fixed object timer values from not saving. (thanks Stoneheart)
  Fixed latest GCC warnings in the /utils. (thanks Jamdog)
  Fixed violent area spells so they would not harm group members. (thanks Nhilar)
  Changed usage of qm->nr to GET_MOB_VNUM(qm). (thanks Tails)
[Jan 21 2009] - Jamdog 
  Added trigedit variable %move% to teleport objects.
  Fixed memory leak in generic_complete_quest.
  A bug fix to player attachable scripts.
  A better fix to the DIKU double attack by ordering a mob to save its master.
  Fix to remove weight restrictions for immortals.
tbaMUD 3.58
[Jan 18 2009] - Rumble
  Updated World and files for 3.58 release.
  Bug fix for column_list to properly display commands, socials, wizhelp, etc. (thanks Jamdog)
[Jan 15 2009] - Fizban
  Immortals can now never have their hands full when you attempt to hand them an item.
[Jan 13 2009] - Rumble
  Questmaster variable changed from an rnum to a vnum. (thanks Jamdog)
  Fixed a bug in dg_variables.c find_replacment with the new quest variable. (thanks Jamdog)
  Fixed message when setting gold abnormally high.
[Jan 09 2009] - Fizban
  Fixed a DIKU bug in do_rescue allowing players to get twice as many attacks per round. (thanks Zordrac)
  Fixed Bug Where Questmaster rnums didn't previously update. (thanks Tails)
[Jan 05 2009] - Rumble
  Fix to allow non-helper aggro mobs be agressive. (thanks Kvasir)
[Dec 28 2008] - Rumble
  Added a "Syntax: export zone vnum" for the export command instead of defaulting to 0. (thanks Vatiken)
  Fixed bad usage of num_of_saving_throws and moved define to structs.h. (thanks Vatiken)
  Added trigedit variables questdone and quest. (thanks Jamdog)
[Dec 23 2008] - Rumble
  Fix for drink containers improperly showing empty due to unlimited container addition. (thanks Parnassus)
  Fix for qedit crash when trying to list non-existent next quest. (thanks Tails)
  Fix for ITEM_NOTE in oedit_disp_val1_menu function in oedit.c. (thanks Parnassus)
[Dec 04 2008] - Fizban
  DG Scripts are now attachable to players (cedit toggle defaults this behavior to off).
[Dec 01 2008] - Fizban
  Now compiles warning free on GCC 4.3.2
[Nov 23 2008] - Rumble
  Fixed a memory leak in quest.c create_obj. (thanks Jamdog)
[Oct 21 2008] - Rumble
  Fixed display of wear locations and a typo. (thanks Kyle)
[Oct 09 2008] - Rumble
  Fixed a small bug in hedit. If CIRCLE_UNSIGNED_INDEX is 0, then new entries won't save correctly. (thanks Rhade)
  Code cleanup of check_idling. (thanks Rhade)
[Sep 01 2008] - Fizban
  Added a check to mzoneecho to stop mortals from using it.
[Aug 31 2008] - Fizban
  Removed various mid-function defines of variables.
[Oct 09 2008] - Rumble
  Fixed a small bug in hedit. If CIRCLE_UNSIGNED_INDEX is 0, then new entries won't save correctly. (thanks Rhade)
  Code cleanup of check_idling. (thanks Rhade)
[Aug 27 2008] - Rumble
  Fixed Mob using '((c)->player_specials->saved.pref)' at dg_variables.c:860
tbaMUD-3.57
[Aug 11 2008] - Rumble
  Updated World and files for 3.57 release. 
[Aug 10 2008] - Fizban
  Added sanity checks to zedit new. (Can no longer make zones that include negative vnums, also get the proper message when you have 3 of the 4 arguments.)
  You can now put objects in and remove objects from closed containers as an imm with nohassle.
  You can now walk through closed doors as an imm with nohassle on.
  You can now open locked containers and doors without unlocking them as an immortal with nohassle.
  You can now examine the contents of closed containers as an imm with nohassle.
  Made zedit new added the .qst file to the index file.
  Fixed various qedit related bugs. (thanks Mirad and Jamdog)
  Removed deprecated "murder" code.
  When pkill is on players can now order charmed mobs to attack other players.
  Fixed 'toggle automap'.
  Added a sacrifice command instead of their being autosac only. Also replaced Zizazat's name with more generic "The Gods" as it had obviously been ported from CWG previously.
  Fixed Warning relating to Automap.
[Aug 03 2008] - Rumble
  You can now see your own communications while sleeping for gos, auc, gra, etc. (thanks Drefs)
  changed str_and_map to use target_room instead of IN_ROOM(ch). (thanks Vatiken)
[Aug 02 2008] - Welcor
  Fixed a one-line bug in act.movement.c - caused crashes when moving into FLIGHT rooms.
[Jul 26 2008] - Rumble
  Fixed autosplit to properly award gold to the person delivering the killing blow and then split it with the group. (thanks Maclir)
  Added checks to qedit for questmaster not being set. (thanks Jamdog)
[Jul 08 2008] - Rumble
  Removed duplicate questpoints listing in stat char. (thanks Mirad)
  Fix to qedit for deleting all quests. (thanks Jamdog)
[Jul 06 2008] - Rumble
  Changed sedit no trade with from undefined to nobits. (thanks Mirad)
[Jul 03 2008] - Rumble
  Fixed lib/messages to properly display skill, spell, and damage messages. (thanks Tink)
[Jun 28 2008] - Rumble
  Added player ability to cancel queued commands. i.e. player spammed kick while fighting but needs to flee so they type '--' to cancel so they can flee. (thanks Jamdog)
[Jun 28 2008] - Fizban
  Merged Jamdog's moblist code into the pre-existing mlist command. (thanks Jamdog)
[Jun 14 2008] - Rumble
  Made immortals immune to blinding.
  Fixed bug in qedit where quest completion would try to load an object with vnum NOTHING. (thanks Jamdog)
  Fixed log when builder tries to edit a zone without permission.
[Jun 12 2008] - Rumble
  Fixed toggle quest to toggle correctly.
  Fixed bug in dg find_replacement to call text_processed at the beginning, regardless of whether something matching the variable is found or not. (thanks Laoris)
  Fixed log error that was using rnum instead of vnum. (thanks Jamdog)
[Jun 11 2008] - Rumble
  Added notification via prompt for new MOTD and news entries. (thanks Jamdog)
  Added all option to the restore command. (thanks Jamdog)
  Added new trigger variable hasattached. (thanks Fizban)
[Jun 10 2008] - Rumble
  Added spec proc type under stat. (thanks Jamdog)
  Only allow immortals to talk while invis and be displayed as "someone." (thanks Frenze)
[May 27 2008] - Rumble
  Fixed list_obj_to_char from only checking invisibility on first object of the same vnum. (thanks Laoris)
  Added object stacking when looking at a character's inventory. (thanks Jamdog)
[May 22 2008] - Rumble
  Added zone name to where command. (thanks Jamdog)
[May 21 2008] - Rumble
  Rewrite of void script_vlog to prevent possible crash bug on some OS's. (thanks Jamdog)
[May 17 2008] - Rumble
  Fixed a possible crash bug in qedit. (thanks Jamdog)
  Bug fix: Page command was paging when the character was not found and sending a NOPERSON message when he was found.
[May 15 2008] - Rumble
  Fixed a bug where deleting the last quest in qedit caused a crash. (thanks Jamdog)
  Updated autorun to fix a random syslog numbering bug. (thanks Arne Troffaes)
[May 10 2008] - Rumble
  Fixed another typo, added a check for !NPC do_gen_comm, and changed do_return to only run autowiz if level changes. (thanks Fizban)
[May 08 2008] - Rumble
  Cleaned up numerous warnings found by adding -Wextra -Wcast-qual -Wshadow -Wno-unused flags.
[May 05 2008] - Rumble
  Changed command do_list_llog_entries to normal function, it was not being used as a command. (thanks Rhade)
  Removed several useless if checks. (thanks Elanthis)
  Fixed zmalloc to work on 64 bit machines.
[May 04 2008] - Rumble
  Fixed numerous warnings for gcc -g -O2 -W -Wshadow -Wcast-qual flags.
  Fixed zpurge mudlog to use zone vnum not rnum. (thanks Jamdog)
  Fix to parse_mobile conversion to 128 bits. (thanks Jamdog)
  Changed autorun.sh from 9091 to 4000. (thanks John Smith)
[Apr 27 2008] - Rumble
  Removed some defunct gemote code. (thanks Fizban)
[Apr 26 2008] - Rumble
  Added README.BSD. (thanks Blix)
  Cleaned up act.comm.c, mobs can now use comm channels. (thanks Rhade)
tbamud 3.56
[Apr 07 2008] - Rumble
  Fixed typos in lib/misc/messages and socials.new
[Apr 04 2008] - jeremyosborne
  Minor Bugfix: All game configuration settings now reference the world config
structure, not the individual config variables found in config.c.
[Mar 22 2008] - Rumble
  Added lib/world/qst/ directory, index, index.mini, and 0.qst.
[Mar 08 2008] - jeremyosborne
  Bugfix: the include directory (for .h files) is now referenced correctly in 
the depend statement.
  Deletion: listrent.c removed as a separate utility.
[Mar 07 2008] - jeremyosborne
  Enhancement: utils/ Makefile will now use a depends file, and looks for 
dependencies in the ../ directory (shrinks the necessary information to make 
each utility).
[Mar 06 2008] - Rumble
  Made TBA specific changes. do_cheat, removed help level checking, and 
advance to level 32 (these will be removed for releases).
[Mar 05 2008] - jeremyosborne
  Minor Update: Changed header of Makefile.in to read 'tbaMUD' and also added 
in attribution for the changes. (Thanks seqwith.)
[Mar 05 2008] - jeremyosborne
  Changed Makefile.in to use glob expressions when building the objects. This 
translates into no longer a need to update Makefile.in whenever a new .c file 
is added to the mud code. Other Makefile.* have not yet been changed (and 
need review, anyway).
  All CXREF cruft left in Makefile.in has been removed. tbaMUD is now using 
Doxygen. Technically, CXREF provides a bit more auto-documentation than Doxygen
does, however the tbaMUD (and legacy circle code) has never been marked-up with 
the special CXREF codes required to effectively use the program. Since Doxygen 
is easier to use, and provides almost as much functionality as CXREF, CXREF 
support has been dropped.
  Bug Fix: asciiflag_conv* functions now can handle a negative numeric value.
  Bug fix/enhancement: Charmed mobs (specifically charmed mobs with a ->master)
will no longer attempt to wander off.
  Based on the compiler warning about mag_materials being an unused function, 
and the clone spell being unused.
  Bug fix: Clone can now be cast. It is an 'ignore' target spell.
  Fix and Modification: Clone, being an effectively unused spell that is only 
used by mortal Magic Users at level 30, is now implemented as very simple 
example of how to use mag_materials(). The item required by mag_materials is 
vnum 161, which in stock tbaMUD is some sacrificial entrails.
  Bug Fix for "Did you mean:" including DG commands.
  Bug Fix: do_simple_move slightly rewritten to handle Leave triggers that 
purge a door.
  Documentation: do_simple_move documented.
[Mar 01 2008] - Laoris
  Trial run of columnizer function on commands list to see how people like it.
[Feb 26 2008] - jeremyosborne
  asciimap, an in game automap, along with a couple of minor bug fixes to do 
with the automap, patched in (Thanks Jamdog).
[Feb 22 2008] - jeremyosborne
  Minor update: Relocate local variable declaration to the top of ACMD(do_help)
  Checked in the following placeholders for do_gen_tog:
#define SCMD_AUTOLOOT   24
#define SCMD_AUTOGOLD   25
#define SCMD_AUTOSPLIT  26
#define SCMD_AUTOSAC    27
#define SCMD_AUTOASSIST 28
  The Autoquest patch, along with a couple of minor bug fixes, has been 
integrated into tbaMUD. (Thanks Jamdog, Kenneth Ray and Morgaelin.)
[Feb 22 2008] - jeremyosborne
  Casted NOWHERE, NOTHING, NOBODY and NOFLAG as IDXTYPE for the signed short 
int index types.
[Feb 18 2008] - jeremyosborne
  Added a new atoidx() conversion function for dealing with string to IDXTYPE 
conversions (in utils.c, prototype exported through utils.h).
  Added IDXTYPE_MIN and IDXTYPE_MAX defines (in structs.h).
  Replaced atoi references with atoidx in do_oasis_zedit (in zedit.c).
  Since general olc editing are automatically saved to disk, 'shutdown reboot' 
has been changed to not-autosave by default. (Small change made to do_shutdown
in act.wizard.c).
  struct attack_hit_type moved to fight.h
  attack_hit_text exported through fight.h
[Feb 17 2008] - jeremyosborne
  do_file heads or tails files correctly and has also been enhanced to return
file info (act.wizard.c).
  Defines made for common log files created by autorun, and those used by 
do_file (db.h).
  utility functions added: file_head(), file_tail(), file_sizeof(), and 
file_numlines() (defined utils.c and exported through utils.h).
[Feb 16 2008] - Rumble
  Fixed export command. (thanks Kyle)
[Feb 15 2008] - jeremyosborne
  Files are now tagged as executable. Should be able to be checked out from 
subversion and executed without running chmod.
[Feb 14 2008] - Rumble
  Fixed strcat() writing out of bounds in cedit.c since strdup() only malloc()
strlen(str)+1 bytes. (thanks Buggo) and moved attack_hit_text back.
  Fixed direction mapping to give readable directions instead of sub commands.
[Feb 13 2008] - jeremyosborne
  Event queue function definitions, global variables and defines doxygenated.
[Feb 12 2008] - Rumble
  Updated levels command to use an arg/range and added color parsing to 
greetings. (thanks Jamdog)
[Feb 11 2008] - jeremyosborne
  Doxygen comments completed for weather.c
[Feb 10 2008] - Rumble
  Corrected several 64-bit warnings. (thanks Buggo)
  Added get_flag_by_name allowing for new trigedit variable checks like 
%actor.pref(FLAG)% checks. (thanks Jamdog)
[Feb 09 2008] - jeremyosborne
  COMPLETE: tbaMUD code re-org of global and local scope function and variable
declarations. There may be a few things that I did not catch (some non extern 
keyword declarations of function prototypes within other functions, for 
example).
  BUG FIX: Unused functions encrypt_hex() and decrypt_hex() removed from mail.c
[Feb 05 2008] - jeremyosborne
  Continued clean-up of 'extern' references to functions and variables.
  BUG UNCOVERED: set_title() in class.c incorrectly handles the const nature of
the char * returned from title_female and title_male.
  More work on mud clean-up.
  New file: spec_procs.h created to house the legacy special procedures 
(spec_procs.c and castle.c) and special feature assignment in general.
  Minor Bugfix: Fixed parse error in mobact.c
  Minor Bugfix: act.h is now included in all of the act functions. Forgot to do
that the first time :(
  Additions: ban.h has been added as the external entry point into the ban.c 
globals and functions. Files needing ban.h have been updated.
[Feb 04 2008] - jeremyosborne
  All act*.c functions, defines and globals have been prototyped/declared in 
act.h. The file act.h does not contain every ACMD, only those ACMDs and 
utility functions available within the act*.c files.
  Changed the 'struct queue' to 'struct dg_queue' to avoid namespace conflicts.
[Feb 04 2008] - Rumble
  Fixed the last few flags missed for the 128 bit conversion.
  Fixed run_autowiz which ran twice on advancement.
[Feb 04 2008] - Laoris
  Adding a column formatter for lists.  Accepts printf-like arguments.
Only used by medit right now.
[Feb 03 2008] - jeremyosborne
  act.h created and added. This header will be the external entry point for the
functions, function subcommands and variables within the act*.c files. It is 
not designed to be the entry point for all ACMD functions.
[Feb 02 2008] - jeremyosborne
  Marking all file scope functions as 'static'
  Reorganization of the global variables and functions.
[Jan 31 2008] - jeremyosborne
  Protected the conf.h.* system config files from multiple calls.
  Removed extraneous references to TRUE / FALSE and YES / NO defines.
  BUGFIX: NUM_POSITIONS set to 8 (was incorrectly set to 15 before)
  Migrated NUM_* settings from oasis.h to more appropriate locations near where
they are defined. (For Example: NUM_POSITIONS moved to structs.h next to the 
POSITION_* defines.)
  Added Appendix A - Coder Support. Right now, it simply speaks to the fact that
we have included doxygen config files, are working to document the source code, 
and provides a rudimentary "do this" guide to create the doxygen cross 
references.
[Jan 30 2008] - jeremyosborne
  All .h files now have doxygen recognized headers, and the format is slightly 
altered to ease editing of headers.
  Protected all .h files from multiple calls. (Standard format is #ifndef _HEADE
R_H_ #define _HEADER_H_ .... #endif)
[Jan 29 2008] - jeremyosborne
  constants.h, structs.h and utils.h now protected from multiple includes. This
is sometimes overkill, but good practice overall.
  Updated documentation for constants.c and constants.h.
  The standard Doxygen configuration doxyfiles (config files) for tbaMUD. One
is to be used with the Graphviz DOT (dox_withGraphs), one is designed to be 
used if Graphviz is not available.
  Minor document correction in struct dex_app_tpe.
[Jan 28 2008] - jeremyosborne
  *bugfix* do_drink command: When a container is empty, the correct, "It is 
empty." message is now displayed.
  Merging changes to trunk for: utils.h, utils.c and structs.h doxygen comments
  Adding file dox_withGraphs.doxyfile
tbaMUD 3.55
[Jan 17 2008] - Rumble
  Updated files for 3.55 release.
  Updated documentation in the /doc directory.
[Jan 16 2008] - Rumble
  New content management system (drupal) at http://tbamud.com. Forums, blogs, etc. (thanks Mordecai)
  Converted all of /doc pdf's back to text files. PDF versions will be on http://tbamud.com
  Updated tell m-w command due to html changes. (thanks Welcor)
  Renamed lib/text/help/screen and iscreen files to help and ihelp.
[Jan 06 2008] - Rumble
  Removed break in oedit_disp_val1_menu ITEM_NOTE that caused a delay. (thanks Rhade)
  Fixed tlist when specifying a range. (thanks Rhade)
[Jan 05 2008] - Rumble
  Fixed improper display of affections in stat player. (thanks Rhade)
[Jan 04 2008] - Rumble
  Removed the unused npc_class_types.
  Fix to affect_update and affect_join. (thanks Kyle and Jamdog)
[ 2007] - Rumble
  Removed the clsolc command. This option can still be set via "toggle clsolc."
[Jan 03 2007] - Rumble
  PLR_NOWIZLIST actually used now to prevent run_autowiz.
  Several _FLAGGED checks that I fixed for 128 bit in the wrong SVN directory and failed to committ.
[Dec 29 2007] - Rumble
  Fixed top_of_helpt bug being off by one. (thanks Jamdog)
  Fixed trigedit copy bug where it used real_room and not real_trigger. (thanks Jamdog)
[Dec 21 2007] - Rumble
  Fixed dg_affect crash caused by a typo on my part.
  Renamed shit again! No really in zmalloc.c unsigned char * shit.
[Dec 15 2007] - Rumble
  Showvnums shows [T#] for a single attached trig or [TRIGS] for multiple attached trigs (except for rooms since there is plenty of room to list all attached trigs).
  Fixed bug where showvnums would not show if attached. (thanks Sryth)
tbaMUD 3.54
[Nov 12 2007] - Rumble
  Updated users command to fix GET_INVIS_LEV bug.
  Updated the drink command to work in rooms where the sector type should logically allow it.
[Nov 04 2007] - Rumble
Increased the size of a mail message from 4k to 8k.
  Updated remove_player so that the players command would not show phantom users when someone self-deletes.
  Updated sedit_rooms_menu to prevent a crash bug when trying to display a shop with rooms that have been removed.
[Nov 01 2007] - Rumble
  Updated mag_objectmagic bug where action description was not being used correctly on scrolls.
  Increased the size of MAX_RAW_INPUT_LENGTH and PLR_DESC_LENGTH.
[Oct 19 2007] - Rumble
  Fixed a few more 128 bit MOB_FLAGGED bugs.
[Oct 17 2007] - Rumble
  Fixed loading of non-128 bit prefs in load_char. (thanks Ziz)
[Oct 15 2007] - Rumble
  Removed some prototypes leftover from the old history command. (thanks Rhade)
[Oct 13 2007] - Rumble
  Updated World, Help, News, Socials, and src for tbaMUD3.54rc.
  Fixed bug where toggling syslog enabled brief. (thanks Rhade)
  Added zone 11.
[Oct 10 2007] - Rumble
  Added OLC menu options for Copying. The Xcopy option is still available for GODs and above.
  Player table is now created if it does not exist. (thanks Rhade)
[Oct 08 2007] - Rumble
  Removed top_shop_offset variable, hopefully fixing the infamous sedit bug.
  Fixed memory leaks from not freeing new zone builders and new zone commands. (thanks Neme)
[Oct 04 2007] - Rumble
  Changed autoexit to display doors as Exits: n (e) w s. DISP_CLOSED_DOORS added to cedit.
  Added rcopy, ocopy, etc. for all forms of OLC. (thanks Neme)
[Oct 01 2007] - Rumble
  Added trigedit variables %zonename% and %zonenumber%. (thanks Drefs)
  Fixed memory leak in do_dig. (thanks Neme)
  Added trigedit variables %roomflag% and object %affects%. (thanks Jamdog)
[Sep 27 2007] - Rumble
  Update to do_hit to prevent crash if the player is AFF_CHARM somehow without a master. (thanks Jamdog)
  Removed alias.c. New ASCII aliases handled in players.c and saved in plrfiles.
[Sep 25 2007] - Rumble
  Added set/not set to extra descriptions menu in oedit so a builder can tell if they exist or not without having to enter the extra desc menu or stat the object.
  Replaced [TRIG] flag (showvnum enabled) with [T<vnum>] to make things easier to stat.
[Sep 24 2007] - Rumble
  Added %is_pc% to return -1 for objects. (thanks Jamdog)
  Fixed do_gen_comm color bleed into last apostrophe in gossip/shout/grat/etc.
  Fixed bug where object keywords took precedence over door keywords. i.e. open door would try to open an object with keyword door. (thanks Trulight)
[Sep 23 2007] - Rumble
  Fixed minlev checks in do_grab, do_wield, and do_wear. (thanks Trulight)
  Added trigedit variables(modifiable) Hunger, Thirst, and Drunk.
[Sep 15 2007] - Rumble
  Fixed bug in unlimited drinks showing as empty. (thanks AaronGoulet)
[Sep 13 2007] - Rumble
  Changed binary search functions (real_xxxx, real_zone_by_thing), except real_shop. (thanks Neme)
  script_proto list freed when exiting without saving in oedit/medit/redit.  (thanks Neme)
  dg_olc.c, trigedit_save(): trig name and arg duping removed. (thanks Neme)
  genobj.c, update_all_obects(): object ID copied, no more 0 uid. (thanks Neme)
  CLEANUP_ALL in redit after saving a room.  (thanks Neme)
  new function in genolc.c: free_save_list(), called during shutdown.  (thanks Neme)
  Event_free_all() now frees all events. (thanks Neme)
  Fixed memory leak in perform_act(). (thanks Rhade)
  Changed NUM_BOARDS from 10 to 7 (the actual num of boards). (thanks Neme)
  Removed the Keywords option in hedit since they have to be in the body.
[Sep 12 2007] - Rumble
  Fixed crash bug caused by olist with no objects. (thanks Rhade)
  Several changes made to compile clean on older versions of GCC. (thanks Neme)
[Sep 10 2007] - Rumble
  Fixed items with rnum = NOTHING or NOBODY being changed to rnum = 0.  (thanks Neme)
  Fixed memory leak in dg_olc.c trigedit save. (thanks Neme)
[Sep 04 2007] - Rumble
  Changed CLSOLC to LVL_BUILDER.
  removed delete_doubledollar from do_say. (thanks Rhade)
[Sep 01 2007] - Rumble
  Made Puff a hidden mob since she is used on room entry trigs to do dg_cast.
  Fixed dg_affect to not add 1 to the desired affect duration.
  Fixed dg_affect to work with 128 bits.
[Aug 17 2007] - Rumble
  128 bit fixes: pfile conversion, world sector conversion, and player flags. (thanks Jamdog)
  Added stop_fighting calls in do_flee to fix stock bug. (thanks Juras)
tbaMUD 3.53
[Jul 01 2007] - Rumble
  Added run_autowiz to do_cheat. (thanks Fizban)
  Updated World and files for 3.53 release.
[Jul 30 2007] - Rumble
  Fixed bad color counting in shop listing. (thanks Ziz)
  Stat zone without arg displays current zone.
[Jun 29 2007] - Rumble
  Added new object variable wearflag.
[Jun 28 2007] - Rumble
  Removed char_from_furniture in do_sit. (Thanks Jamdog)
  Replaced strcasecmp and strncasecmp with str_cmp and strn_cmp. (Thanks Khorlane)
[Jun 26 2007] - Rumble
  Added Jamdog's "complete" screen.h. (Thanks Jamdog)
  Updated hedit to Rhade's cleaner version. (thanks Rhade)
[Jun 25 2007] - Rumble
  Added questpoints to load_char and set autoexit on by default. (thanks Trulight)
[Jun 20 2007]
  Fixed many more bugs from the 128 bit patch.
[Jun 16 2007] - Rumble
  Missed replacing NUM_SPELLS -1 with NUM_SPELLS, corrected. (thanks Kyle)
[Jun 01 2007] - Rumble
  Renamed Gossip: to Gemote: to match the command when players use gemote.
  Added channel emotes by matching player name to first word. i.e. gossip
  rumble sporks Manivo ruthlessly. (thanks Mordecai)
  Renamed squelch to mute to match the command.
[May 17 2007] - Rumble
  Added AFF_FLYING/SCUBA and appropriate checks in act.movement.c. Room sector types IN FLIGHT and UNDERWATER are finally being used!
  Removed all of the Dragon_Breathes.
  Removed context help system.
  Added invis level on reconnect.
[May 15 2007] - Rumble
  Fixed object stacking to match s-desc and item_number.
  Added wizupdate command.
  Added valid_dg_target check to object remove trigs.
  Fixed shops and affects to work with 128 bits.
  Removed Hometown and Languages.
[May 09 2007] - Rumble
  Fixed nogos/nowiz from flagging everyone in who.
  Fixed numerous SYSERR's where mobs were using player only specials.
  Added 128 bits patch by Niese Petersen with numerous updates and fixes.
tbaMUD 3.52
[Apr 14 2007] - Rumble
  IP's only visible to LVL_GOD and above now for the paranoid people out there.
[Apr 13 2007] - Rumble
  Finally made gemote actually work like emote and not just use socials. (thanks Fizban)
  Reworded and standardized the trigedit attachment menu.
  Numerous minor fixes taken from the latest CWG release. (thanks Zizazat)
  Update to is_number to check for negative numbers. (thanks Kyle)
  Update to isname to disallow abbreviated numbers. (thanks Sryth)
[Apr 08 2007] - Rumble
  Removed all usage of CAP(str) causing a memory leak (thanks Kyle).
  Removed object type TRAP.
  Removed oasis_delete.h.
  Renamed variable wovel to vowel in ban.c.
  Renamed several functions to lower case.
[Apr 02 2007] - Rumble
  Stopped Checking abbrevs with doors so players can't spam open a, open b, etc.
  Added questpoints!
[Mar 30 2007] - Rumble
  Added unlimited fountains and containers (Thanks Adam Scriven).
  Removed object types MISSILE and FIRE WEAPON.
  Removed the do_oasis function and called the Xedit commands directly (thanks Rhade).
[Mar 25 2007] - Rumble
  Updated idle timer to keep track of imms too (thanks Jamdog).
  Standardized OLC messages.
  Updated README.WIN, README.MSVC8, and README.CYGWIN.
[Mar 20 2007] - Rumble
  Added object type FURNITURE (thanks Dark).
  Added ZZZ directories to plrfiles and plrvars (thanks Zizazat).
  Added 00 files to plrfiles directories (thanks Khorlane).
  Added mail check at reconnect and when coming back from AFK.
[Mar 19 2007] - Rumble
  Added JamDog's updated levenshtein_distance that compiles clean with MSVC++.
  Added AFK to player L-desc.
  Cleaned up the code by running it through a g++ compiler (thanks Rhade).
  Added AFK to the prompt.
  Stop snooping at do_quit to prevent snooping of passwords on deletion or password reset.
[Mar 17 2007] - Rumble
  Fixed locate object spell (thanks JamDog).
  Added plist and and improved history command (thanks Rhade).
  Renamed immort_level_ok to no_mort_to_immort and rewrote the convoluted comments.
[Mar 04 2007] - Rumble
  Fixed fight_messages not displaying (thanks Rhade).
  Removed LVL_FREEZE and set ban/freeze to LVL_GRGOD.
  Added send_cannot_edit function (thanks Rhade).
[Feb 26 2007] - Rumble
  updated CYGWIN.README, FAQ, and README
  Added an in game changelog command (thanks Rhade).
  Moved do_file to act.wizard.c.
  Alphabetized Makefile.in, yeah I'm anal like that.
  Clarified licheck so people know to enter Q to accept the license and quit.
[Feb 25 2007] - Rumble
  Fixed oat and wat (thanks Rhade).
  Numerous social fixes (thanks Rhade, Fizban, and Amber).
  Removed do_insult.
  Cleaned up hedit formatting and fixed possible bug from editing a help file
    you can't view (thanks Rhade).
  Fixed cast ' ' so it won't cast armor (thanks Rhade).
 
tbaMUD 3.51
- Removed the extra space when you have no title (thanks Rhade).
- Added "Top of File" to the do_file command (thanks Rhade).
- Removed socials from wizhelp (thanks Rhade).
- Changed zlist with no arg to list zones (thanks Rhade).
- Wiznet can now be seen while in OLC, again (thanks Fizban).
- Removed MOBprograms.
- Added ALL_PERMISSIONS so anyone with OLC can have access to the entire World.
  Included set <player> olc all. (thanks Rhade).
- Fixed color bleeding from listing consecutive mobs (yellow) and objs(green)
  in room or vice versa (thanks Rhade).
- Removed trg/index double entries (thanks Fizban).
- Cleaned up search_help and do_helpcheck. Now using player level instead of 
  the entire char structure (thanks Rhade).
- Fixed do_sstat_room so stat can display more than just the room you are 
  standing in (thanks Rhade).
- Fixed crash if you try to boot the game without a shop (thanks Rhade).
- Added online mail notification, "You have mail." as soon as mudmail is sent
  (thanks JamDog) and when coming back from afk (thanks Rhade).
- Removed strip_string function; strip_cr does the same thing (thanks Rhade).
- Released tbaMUD3.51rc.
- Limited trigedit numeric arg to 0-100.
- Removed the magic numbers for setting DRUNK, HUNGER, THIRST. 
- Renamed FULL to HUNGER.
- Changed page to level 1.
- Snooping log message is now only visible by higher imms.
- Moved nohassle, holylight, showvnums, color, compact, syslog, poofin, 
  poofout, and autoexit to toggle <option>.
- Added "Did you mean" to unknown commands instead of Huh?!? (thanks Rhade).
- Updated do_set Alphabetically. Removed set idnum & lessons (practice still 
  there). Can no longer set level to 0 (thanks Fizban).
- Added autoloot, autogold, autosplit, autosac, and autoassist.
- Removed all whitespace (tabs and spaces at EOL).
- Added years to messages (thanks Rhade).
- Updated version and files to new name: tbaMUD!
- Renamed medit_alias and oedit_namelist to _keyword for consistency.
- Moved numerous protos only used once from .h files to appropriate .c file
  (thanks Del).
- Renamed numerous functions for clarity (mostly shop functions like copy_list
  to copy_shop_list, etc) (thanks Del).
- Renamed update_objects to update_all_objects so it wouldn't be confused with
  update_object (thanks Del).
- Renamed data to dg_data in function queue_head in dg_event.c for clarity
  (thanks Del).
- Moved function log_death_trap to a log since that is all it did anyways
  (thanks Del).
- Renamed unmatched gettimeofday protos  (thanks Del).
- Renamed oasis_copy.o and oasis_list.o to appropriate .c for CXREF_FILES.
- Fixed a bunch of strange bugs in objsave.c and altered build_player_index() 
  to conform to gcc 4.1 standards. This mainly consisted of removing a cast 
  which was not needed. 
- Replaced kill_ems() with strip_cr(), for consistency.
- Updated Makefile.*.
- Removed redundant olc.c, oasis_delete.c, olc.h and tedit.h files from the 
  build. Added prototypes for the new variable save functions to players.c
- DG script variables now save to the player file instead of their own file. 
  The load function has been kept for backwards compatibility.
- Moved alias saving to Ascii pflies by default. Aliases in the old files will 
  still be read (once per char).
- do_toggle actually toggles everything now (thanks Rhade). Moved slowns, 
  track, syslog, pagelength, wimpy, and color to toggle <option> <arg>. Keeping
  do_gen_tog so the old command toggles still work.
- Immortals no longer have to pay to mudmail.
- Autosaved aliases.
- Added afk to do_set.
- Removed unused olc_bitvector and save_etext functions.
- Added min_level check to hindex.
- Fixed zlist and index files 
- Renamed roomflags to showvnums.
- Mini world zone 0, 12, 30 error free (Added 1.trg to index.mini for examples)
- Updated errors for no time/config files.
- Added -l(eader) and -g(rouped) options to do_who (thanks Rhade).
- Added MERC license and help entry.
- Spellchecked stock.hlp.
- Updated fixes from 3.1 CVS snapshot.
- Fixed permissions on numerous files.
- Renamed shit. No really; in zmalloc.c unsigned char * shit;
- Spellchecked help.hlp.
- Updated /doc/README.Cygwin.
- Updated /doc/syserr.txt (much more to do though, along with all /doc, 
  submissions welcome).
- Modified all comments referring to old playerfile and removed obsolete code.
- Removed .accepted, conf.h, and Makefile. 
- Moved text/hedit to text/help directory. Now 2 help files to choose from 
  help.hlp (TBA's helpfiles) and the oldhelp directory.
- Fixed error from adding poofs to do_stat and not checking !IS_NPC.
- Fixed help search so it checks player level so HELP AC can exist as a mortal
  helpfile and an immortal helpfile.
- Fixed hindex to check help entry level.
- Added house saving call to do_saveall.
 
CircleMUD 3.5
- New do_who by Rhade.
- Core files generated with unique time stamp.
- Updated README, FAQ, news.
- Removed all CIRCLEMUD_VERSION and #IF 0 debugging checks.
- Renamed _DEAF to _NOSHOUT.
- Added greetings, ihelp, wizlist, and immlist to tedit.
- Changed all usage of dscr to desc for standardization.
- Increased PLR_DESC_LENGTH from 240 to 512.
- Renamed EXDSCR_LENGTH and CON_EXDESC to PLR_DESC_LENGTH and CON_PLR_DESC.
- Moved lastlist (lists entire last file) to last *.
- Removed edit command.
- Fixed everything so MUD would load error free in mini mode.
- Moved cheat to return. If not in a mob typing return will advance you to the
  level specified in do_cheat. IDNUM 1 advanced to IMPL
- Changed OLC to default to off, again.
- Added Ascii Pfiles V3.0.1
- Added pagelength to toggle.
- Update to list_obj_to_char for object stacking and iedit objects.
- Increased MAX_STRING_LENGTH to 49152.
- Moved poofin/out to set self poofin/out. 
- Removed poofs command, poofs can be viewed under stat or score.
- Isname updates.
- Added mob/obj delete.
- Update to delete_room to remove the room from the htree.
- Counts colorcodes now when formatting in the text editor.
- Update to create_new_zone to correct buildwalk issues after a new zone is created.
- Added zpurge, checkload and zcheck Immortal commands.
- Doubled MAX_INPUT_LENGTH to 512.
- Usage: attach { mtr | otr | wtr } { trigger } { name } [ location ]
- Usage: detach [ mob | object | room ] { target } { trigger | 'all' }
- Added show zone <name> option.
- Added look around command.
- Fixed hidden object stacking.
- Added vnum room/trig options to search by name.
- Added hedit, helpcheck and hindex. Plus seperate imm/mort screens.
- Added hidden mobs. medit-l-desc beginnin with a period (.) can only be seen 
  with holylight.
- Update to zreset and do_links.
- Added paragraph option in the text editor /f 4-8 to make a para lines 4-8.
- Object stacking fix, only stack if they are the same vnum AND short descr.
- Update to do_hit to prevent crash if the player is AFF_CHARM somehow without 
  a master.
- Added Did you mean? to non-existing helpfile query.
- Added TBA's donated zones to stock.
- DG Scripts 1.0.14.
- Set OLC options #, aedit, hedit, off.
- Updates to parse_object, oedit_disp_perm_menu and oedit_parse to remove the 
  ability of setting AFF_CHARM as on object perm affect. Setting this on a 
  player (without having a clearly defined MASTER) causes a crash.
- Added social gossip bug fix in do_gen_comm to give commands priority.
- Did away with the #ifndef STOCK_CIRCLE tags.  
- Removed some unused code from cedit_creation.
- Update MAX_STRING_SIZE.
- Update to do_gen_comm to make gemote and gossip behave the same for socials.
- Update to do_gen_comm to remove SYSERRs generated while switched into mobs.
- Update to SPECIAL(shop_keeer) so that MSG_NO_STEAL_HERE is sent TO_ROOM as 
  well as TO_CHAR.
- Update to zedit_parse.
- Expanded zones to unsigned int. NOWHERE/corpse is now 65535, not -1
- Added PRF_AFK.
- Updated load_zones to fix reported bug with behavior of the 'Set a global 
  variable' zedit command.
- Replaced calls for ch|vict|obj->in_room to IN_ROOM(ch|vict|obj). Use of 
  the macro is better.
- Autosave everything except Buildwalk, dig, and rdelete.
- Corrected minor typo in parse_class which is part of stock Circle 3.1.
- Updates to free_room_strings, free_room, and free_srings.
- Change to free_strings() in oasis_delete.c related to freeing extra descs.
- Also made changes to copyover/saved room code for more logical behavior.
- Removed @ as save character in the text editor since it is a color code.
- Update to do_dig.
- Change to remove_unique_id to plug mem leek.
- Changes in dg_comm.c!
- Added look_in_obj fix which was causing conflicts between room keywords and 
  object keywords. 
- Changed to unsigned int to double zones.
- Added some missing dg_scripts related logic to save_char.
- Added do_gemote command which allows you to emote over the gossip channel.
- Changed the color code character from '&' to '@'. 
- Fixed color bleeding in all the lists.
- Added IMM command peace to stop all fighting in that room.
- Fix for LOADROOM and copyover conflicts.
- Changed copyover to save room player was in.
- Made an option so shopkeepers never go broke.
- Added Welcor's manual_color update with numerous updates.
- replaced numerous special procedures with triggers (still some to go).
- Removed leftover debug message from dg_mobcmd.c
- Removed duplicate code in zedit.c related to who can do zone edits.
- Corrected logic in object get code which was out of order.
- Fix to read_mobile in db.c, was causing mobs to be assigned triggers twice.
- Fixed /fi to not add two spaces after quoted "text."
- Patched in Oasis 2.0.6
- Set OLC to off on immortal advance
- Changes in enter_player_game to use calls from CONFIG_ defs used by CEDIT. 
- Fixes to redit.c for ROOM FLAGS.
- Added objstacking.
- Changed valid_dg_target to allow everyone to trigger except IMPL
- Change to save_char related to problems with the copyover function.
- Fixed buildwalk from continuing into next zone.
- Added Aedit, Astat, and over 100 new socials.
- Replaced all ch->in_room calls with IN_ROOM(ch) for general cleanliness.
- Changed default olc to be -1 not 0.
- Wiznet is now visible in OLC.
- Added hidden objs. oedit-l-desc beginnin with a period (.) can only be seen 
  with holylight.
- Fixed tilde in room desc crash (and other world files).
- Fixed socials taking precedence over commands and not allowing abbrevs.
- Changed do_simple_move so players couldn't find hidden exits by trying to 
  walk into them.
- Fixed shopkeepers so they could sell just one item.
- Fixed oedit where it did not recognize any change when modifying just weight
  or values.
- Some minor changes to redit in the way it interacts with door flags.
- Added online dictionary. Tell m-w <word>.
- Bugfix for enchant_weapon spell.
- Added LVL_BUILDER.
- Bugfix for locate_object spell.
- Fixed all the OLC crashes from large numbers. Weight, cost, max contain, exp,
  gold, and fountain contains to name a few.
- Save room on copyover reboot.
- Dg_scripts update to calls in spell_recall and spell_teleport.
- Fixed mhunt.
- Made all imm commands requiring zone # default to current zone if no arg.
- Add formatting for trigedit. /f indents to make things easier to read.
- Zero level mobs are set to level 1 in db.c.
- Added links command.
- Fixed social bodyparts.
- Added mail saving.
- Fixed Enter spell (0 for none): having 0 spell causes error, should be -1.
- Added /r/n to "gate is closed from the other side" and "cool immortal."
- Fixed variable file not deleting at player deletion.
- Fixed the 2 shopkeepers one room crash.
- Fixed colorcodes preventing capitalization.
- Fixed /f, /fi creating an extra line.
- Made object values reset when type is changed.
- Added vdelete [*].
- Fixed where so players in OLC would be listed.
- The weapon dice check now works.
- All olc files uses the can_edit_zone() function where appropriate.
- Added OLC permissions to attach and detach.
- Made it possible  to use one shopkeeper for more than one shop.
- Restore skills and spells on advancement.
- Added context help system, lib/text/contexthelp.
- Fixed sedit crash caused by deleting room that where shops.
- Added don't parse character \, use %% for %.
- Fixed rdelete crash from deleting a room that is linked to itself.
- Fixed exits to default to -1 instead of 0 when just making an edit desc.
- Added a warning if a NOTE has an extra desc.
- Fixed practice to show skills with 0 practices remaining.
- Added file <option> to view logs.
- Added several new names to the xnames file.
- Added copyover.
- Improved the last command.
- Added switched people to the who list.
- Added zedit commands to stat room.
- Added triggers and shops to show stat.
- Added more info to all the vstat options.
- Added invis level at login to prevent greeting imms who are hiding.
- Added delete option to extra desc's. Just /c.
- Added history command to show last 100 comms.
- Added an export command that will QQ and compress a zone.
- Numerous new logs for force, buildwalk, delete, snoop, etc.
- Added vnum and TRIG tags to everything, showvnums toggles it on/off.
- Added keyword seperation when statting extra desc. [desk] [notes papers]
- Added buildwalk and dig.
Major Additions:
OasisOLC 2.0.6
trigedit (DG Scripts) 1.0.14
hedit (help editor)
cedit (config editor)
tedit (text file editor)
aedit (socials editor)
qedit (quest editor)
ANSI Color
ASCII Player Files 3.0.1
128bit Support
Copyover
automap (ASCII map generator)
buildwalk (walk a new zone to link rooms)
tell m-w (an in game dictionary lookup)
gemote (emotes over gossip)
history (of all communications, tells, gossip, etc.)
file (allows imms to view syslog, errors, etc.)
pagelength (custom pagelength setting)
showvnums (roomflags that includes mobs, objs, triggers)
zpurge (purge an entire zone)
zcheck (head builder tool to check balancing)
mob autoroll (standard values set on mob level entry)
checkload (list where a mob/obj/trg is loaded)
Auto Toggles (loot, gold, split, sac, assist, map, door, key)
Hidden mob/obj
mob/obj stacking
hindex
helpcheck
OLC copy and delete options.
export (QQ's a zone into a tarball)
Xlist (mlist, olist, rlist, zlist, slist, tlist, qlist)
(lots of major bugfixes too)
 
tbaMUD Release history:
tbaMUD 2019, January 2019
tbaMUD 2018, January 2018
Version 3.68 release: February, 2017
Version 3.67 release: January, 2016
Version 3.66 release: January, 2015
Version 3.65 release: January, 2014
Version 3.64 release: March, 2013
Version 3.63 release: April, 2012
Version 3.62 release: September, 2010
Version 3.61 release: January, 2010
Version 3.60 release: September, 2009
Version 3.59 release: April, 2009
Version 3.58 release: January, 2009
Version 3.57 release: August, 2008
Version 3.56 release: January, 2008
Version 3.55 release: January, 2008
Version 3.54 release: December, 2007
Version 3.53 release: July, 2007
Version 3.52 release: April, 2007
Version 3.51 release: February, 2007
Version 3.5 release: December, 2006
See releases.txt for older versions of CircleMUD not released by TBA.
